<template>
  <v-list-group v-model="opened">
    <!-- Activator tile -->
    <v-list-tile slot="activator" @click="$emit('click', $event)">
      <v-list-tile-action>
        <v-icon>mdi-shape</v-icon>
      </v-list-tile-action>
      <v-list-tile-content>
        <v-list-tile-title>{{ name }}</v-list-tile-title>
        <v-list-tile-sub-title>{{ itemCount}}</v-list-tile-sub-title>
      </v-list-tile-content>
      <v-spacer/>
      <!-- Open shop action -->
      <v-btn
        icon
        title="Open Shop"
        @click="$router.replace({name: 'store', params: {group_id: id}})"
      >
        <v-icon>mdi-store</v-icon>
      </v-btn>
      <!-- Edit action -->
      <v-btn icon title="Update Group" @click.prevent="$refs.updateGroupDialog.open()">
        <v-icon>mdi-pencil</v-icon>
      </v-btn>
      <!-- Add product -->
      <v-btn icon title="Add Product" @click.prevent="$refs.addProductToGroupDialog.open()">
        <v-icon>mdi-plus</v-icon>
      </v-btn>

      <add-product-to-group-dialog ref="addProductToGroupDialog" :id="id"/>
      <update-group-dialog ref="updateGroupDialog" :id="id"/>
    </v-list-tile>

    <!-- Products in this group -->
    <product-list-item v-for="product in products" :key="product.id" :id="product.id">
      <template slot="actions">
        <v-btn icon title="Remove From Group" @click="removeFromGroup(product.id)">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </template>
    </product-list-item>
  </v-list-group>
</template>

<script>
import gql from "graphql-tag";
import ProductListItem from "@/components/list-items/ProductListItem";
import UpdateGroupDialog from "@/components/dialogs/UpdateGroupDialog";
import AddProductToGroupDialog from "@/components/dialogs/AddProductToGroupDialog";

export default {
  name: "card-list-item",
  components: { ProductListItem, UpdateGroupDialog, AddProductToGroupDialog },
  props: {
    id: { type: String, required: true }
  },
  data() {
    return {
      opened: false,
      group: null // Dialogs
    };
  },
  computed: {
    name() {
      if (!this.group) return null;
      return this.group.name;
    },
    elements() {
      if (!this.group) return null;
      return this.group.products.length;
    },
    products() {
      if (!this.group) return [];
      return this.group.products;
    },
    itemCount() {
      return `${this.elements} item${this.elements != 1 ? "s" : ""}`;
    }
  },
  apollo: {
    group: {
      query: gql`
        query($id: ID!) {
          group: productGroup(id: $id) {
            id
            name
            products {
              id
            }
          }
        }
      `,
      subscribeToMore: {
        document: gql`
          subscription($id: ID!) {
            productGroup(id: $id) {
              id
              name
              products {
                id
              }
            }
          }
        `,
        variables() {
          return {
            id: this.id
          };
        }
      },
      variables() {
        return {
          id: this.id
        };
      }
    }
  },
  methods: {
    async removeFromGroup(product_id) {
      try {
        await this.$apollo.mutate({
          mutation: gql`
            mutation($id: ID!, $product_id: ID!) {
              productGroupRemove(id: $id, product_id: $product_id) {
                id
              }
            }
          `,
          variables: {
            id: this.id,
            product_id
          }
        });
      } catch (e) {
        console.error(e);
      }
    }
  }
};
</script>
